#include <xc.h>
#include <pic16f886.h>
#include "port_init.h"
#include "user_define.h"
#include "ad.h"
#include "wait_time.h"
#include "lcd_sub.h"

#pragma config BOREN = OFF
#pragma config CPD = OFF 
#pragma config FOSC =INTRC_NOCLKOUT  
#pragma config MCLRE = ON 
#pragma config WDTE = OFF 
#pragma config CP = OFF 
#pragma config LVP = OFF 
#pragma config PWRTE = ON
#pragma config IESO =OFF
#pragma config FCMEN = OFF

#pragma config BOR4V = BOR21V
#pragma config WRT = OFF

//unsigned long	hz_no;
unsigned long	freq_no;
unsigned long	freq_no_m;
unsigned int	vol_data;
unsigned char	out_flg;
unsigned char	vol_mode;
unsigned char	step_flg;
unsigned char	hen_d[24];
unsigned int	vol_count;
unsigned int    disp_count;
unsigned char   ms_mode;
unsigned int    ms_count;
unsigned int    ms_level;

//unsigned char   wave_mode;
unsigned int    level_count;
unsigned int    level_data;
unsigned int    level_st[5];
unsigned int    level_st_count;

unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw3_cnt;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw4_cnt;

unsigned char	sw1p;
unsigned char	sw2p;
unsigned char	sw3p;
unsigned char	sw4p;

/*---------------------FREQ-----------------------*/
void	freq_no_inc(void)
{
	switch(vol_mode){
        case 0: freq_no=freq_no+1;
                break;
        case 1: freq_no=freq_no+2;
                break;
        case 2: freq_no=freq_no+5;
                break;
        case 3: freq_no=freq_no+10;
                break;
        case 4: //freq_no=freq_no+50;
                freq_no=freq_no/50;
                freq_no=freq_no*50; 
                freq_no=freq_no+50;        
                break;
        case 5: //freq_no=freq_no+100;
                freq_no=freq_no/100;
                freq_no=freq_no*100; 
                freq_no=freq_no+100;           
                break;
    }
	if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
}

void	freq_no_dec(void)
{
	switch(vol_mode){
        case 0: freq_no=freq_no-1;
                break;
        case 1: freq_no=freq_no-2;
                break;
        case 2: freq_no=freq_no-5;
                break;
        case 3: freq_no=freq_no-10;
                break;
        case 4: //freq_no=freq_no-50;
                if(freq_no>50){
                    if((freq_no % 50)==0){
                        freq_no=freq_no-50;
                    }
                    else{
                        freq_no=freq_no/50;
                        freq_no=freq_no*50;
                    }
                }        
                break;
        case 5: //freq_no=freq_no-100;
                if(freq_no>100){
                    if((freq_no % 100)==0){
                        freq_no=freq_no-100;
                    }
                    else{
                        freq_no=freq_no/100;
                        freq_no=freq_no*100;
                    }
                }                
                break;
    }
	if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
}

void	freq_no_inc_1k(void)
{
unsigned long	step;

	switch(vol_mode){
		case 0:	step=10;break;
		case 1:	step=20;break;
		case 2: step=50;break;
		case 3:	step=100;break;
        case 4: step=500;break;
        case 5: step=1000;break;
	}

	freq_no=freq_no/step;
	freq_no=freq_no*step; 
	freq_no=freq_no+step;
	if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
}

void	freq_no_dec_1k(void)
{
unsigned long	step;

	switch(vol_mode){
		case 0:	step=10;break;
		case 1:	step=20;break;
		case 2: step=50;break;
		case 3:	step=100;break;
        case 4: step=500;break;
        case 5: step=1000;break;
	}

	if(freq_no>step){
		if((freq_no % step)==0){
			freq_no=freq_no-step;
		}
		else{
			freq_no=freq_no/step;
			freq_no=freq_no*step;
		}
	}
	else{
		freq_no=FREQ_MIN;
	}
}

/*---------------------AUTO FREQ INC--------------*/
void    freq_next(void)
{
    if((freq_no>=20) && (freq_no<100)){freq_no=freq_no+2;}
    else{
        if((freq_no>=100) && (freq_no<1000)){freq_no=freq_no+10;}
        else{
            if((freq_no>=1000) && (freq_no<10000)){freq_no=freq_no+100;}
            else{
                if((freq_no>=10000) && (freq_no<100000)){freq_no=freq_no+1000;}
                else{
                    if((freq_no>=100000) && (freq_no<990000)){freq_no=freq_no+10000;}
                }
            }
        }
    }
}    
/*---------------------AUTO LEVEL OUT-------------*/
void    level_out(unsigned long freq,unsigned int level)
{
unsigned char   i;

    LEVEL_CLK=0;
    LEVEL_DATA=0;
    
    for(i=0;i<16;i++){
        if((level & 0x01)==0x01){
            LEVEL_DATA=1;
        }
        else{
            LEVEL_DATA=0;
        }
        wait_time(5);
        LEVEL_CLK=1;
        wait_time(5);
        LEVEL_CLK=0;
        wait_time(5);
        level=level >> 1;
    }
     for(i=0;i<24;i++){
        if((freq & 0x01)==0x01){
            LEVEL_DATA=1;
        }
        else{
            LEVEL_DATA=0;
        }
        wait_time(5);
        LEVEL_CLK=1;
        wait_time(5);
        LEVEL_CLK=0;
        wait_time(5);
        freq=freq >> 1;
    }
    LEVEL_CLK=0;
    LEVEL_DATA=0;

}
/*---------------------AD9834---------------------*/
void    ad9834_data_out(unsigned int data)
{
unsigned int i,mdata;

    mdata=data;
    DDS_FSYNC=1;
    DDS_SCLK=1;
    DDS_FSYNC=0;
    for(i=0;i<16;i++){
        if((mdata & 0x8000) == 0x8000){
            DDS_SDATA=1;
        }
        else{
            DDS_SDATA=0;
        }
        wait_time(2);
        DDS_SCLK=0;
        wait_time(2);
        DDS_SCLK=1;
        wait_time(2);
        mdata=mdata <<1;
    }
    DDS_FSYNC=1;
}

void    ad9834_freq_set(unsigned long data,unsigned char data2)
{
    unsigned long mdata;
    
    switch(data2){
        case 1:     ad9834_data_out(AD9834_SIG_ON_DATA);
            break;
        case 0:     ad9834_data_out(AD9834_SIG_OFF_DATA);
            break;
    }
    mdata=data*4;
    mdata=(mdata & 0x3fff) | 0x4000;
    ad9834_data_out(mdata);
    mdata=data*4;
    mdata=mdata >> 14;
    mdata=(mdata & 0x3fff) | 0x4000;
    ad9834_data_out(mdata);
}

/*---------------------MAIN-----------------------*/
void	main(void)
{
unsigned char   flg;

	port_init();

	out_flg=0;
	vol_mode=0;
	vol_count=0;
    level_count=0;
    level_st_count=0;
    disp_count=0;
    ms_mode=0;
    ms_count=0;
    ms_level=0;
	step_flg=0;
 
	__delay_ms(500);
    
	sw1_key=0;sw1_rep=0;sw1_cnt=0;
	sw2_key=0;sw2_rep=0;sw2_cnt=0;
	sw3_key=0;sw3_rep=0;sw3_cnt=0;
	sw4_key=0;sw4_rep=0;sw4_cnt=0;
	__delay_ms(100);
    
    
    //wave_mode=0;

    flg=0;

    lcd_init();
    lcd_clear();
 	lcd_xy(14,1);
	lcd_print("Hz");
    
    lcd_xy(12,0);
    lcd_print(". dB");
    
    lcd_range(vol_mode);
    
    freq_no=FREQ_MIN;
    lcd_hz(freq_no);
    lcd_mode();
    ad9834_freq_set(freq_no,out_flg);
    
	while(1){
		sw1p=RC0;NOP();
		sw2p=RC1;NOP();
		sw3p=RC2;NOP();
		sw4p=RC3;NOP();
        
        /* key scan 1 */
		if (sw1p==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if (sw2p==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if (sw3p==0){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/
		if (sw4p==0){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/
        
		wait_time(1000);

		sw1p=RC0;NOP();
		sw2p=RC1;NOP();
		sw3p=RC2;NOP();
		sw4p=RC3;NOP();
        
        /* key scan 2 */
		if ((sw1p==0)&&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if ((sw2p==0)&&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if ((sw3p==0)&&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/
		if ((sw4p==0)&&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/

        /* key action */
	
		if((sw1_key==0)&&(sw1_rep==0)){
			sw1_rep=1;
            if(ms_mode==1){
                ms_mode=0;
                disp_count=DISP_LOOP_SET;
                lcd_mode();
            }
            else{
                switch(out_flg){
                    case 0: out_flg=1;
                            ad9834_freq_set(freq_no,out_flg);
                            lcd_mode();
                            break;
                    case 1: out_flg=0;
                            ad9834_freq_set(freq_no,out_flg);
                            lcd_mode();
                        break;
                }
            }
		}
		/*------------------*/
		if((sw1_key==0)&&(sw1_rep==1)){
			sw1_cnt++;
			if(sw1_cnt>=KEY_LONG_MS){
					sw1_cnt=0;
                    switch(ms_mode){
                        case 0: sw4_cnt=0;
                                ms_mode=1;
                                out_flg=1;
                                freq_no=20;
                                lcd_hz(freq_no);
                                ad9834_freq_set(freq_no,out_flg);
                                disp_count=DISP_LOOP_SET;
                                ms_count=MS_COUNT_LONG;
                                level_st_count=0;
                                level_count=LEVEL_COUNT_SET;
                                lcd_mode();
                                break;
                        case 1: 
                                break;
                    }
			}
		}
		/*------------------*/
		if((sw2_key==0)&&(sw2_rep==0)){
			sw2_rep=1;
            if(ms_mode==0){
                if(step_flg==0){
                    switch(vol_mode){
                        case 0: vol_mode=1;
                                break;
                        case 1: vol_mode=2;
                                break;
                        case 2: vol_mode=3;
                                break;
                        case 3: vol_mode=4;
                                break;
                        case 4: vol_mode=5;
                                break;
                        case 5: vol_mode=0;
                                break;
                    }
                    lcd_range(vol_mode);
                    step_flg=0;
                }
                else{
                    switch(vol_mode){
                        case 0: vol_mode=0;
                                break;
                        case 1: vol_mode=1;
                                break;
                        case 2: vol_mode=2;
                                break;
                        case 3: vol_mode=3;
                                break;
                        case 4: vol_mode=4;
                                break;
                        case 5: vol_mode=5;
                                break;
                    }
                    lcd_range(vol_mode);
                    step_flg=0;                    
                }
            }
            lcd_mode();
		}
		/*------------------*/
		if((sw2_key==0)&&(sw2_rep==1)){
			sw2_cnt++;
			if(sw2_cnt>=KEY_LONG_UD){
					sw2_cnt=0;

                    
			}
		}

		/*--------------------*/

		if((sw3_key==0)&&(sw3_rep==0)){
			sw3_rep=1;
            if(ms_mode==0){
                freq_no_inc();
                lcd_hz(freq_no);
                ad9834_freq_set(freq_no,out_flg);
                step_flg=1;
            }
            lcd_mode();
                        
		}
        
		/*------------------*/
		if((sw3_key==0)&&(sw3_rep==1)){
			sw3_cnt++;
			if(sw3_cnt>=KEY_LONG_UD){
                if(ms_mode==0){
					sw3_cnt=0;
					freq_no_inc_1k();
					lcd_hz(freq_no);
                    ad9834_freq_set(freq_no,out_flg);
					step_flg=1;
                }
                lcd_mode();
			}
		}        
        
		/*------------------*/
		if((sw4_key==0)&&(sw4_rep==0)){
			sw4_rep=1;
            if(ms_mode==0){
                freq_no_dec();
                lcd_hz(freq_no);
                ad9834_freq_set(freq_no,out_flg);
                step_flg=1;
            }
            lcd_mode();
		}

		/*------------------*/
		if((sw4_key==0)&&(sw4_rep==1)){
			sw4_cnt++;
			if(sw4_cnt>=KEY_LONG_UD){
                if(ms_mode==0){
					sw4_cnt=0;
					freq_no_dec_1k();
					lcd_hz(freq_no);
                    ad9834_freq_set(freq_no,out_flg);
					step_flg=1;
                }
                lcd_mode();
			}
		}        
		/*------------------*/


		/*------------------*/        
        
        if(ms_mode==0){
		if(step_flg==0){
		/**/
		if(vol_mode==0){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				vol_data=vol_yomi();
				freq_no=(unsigned long)vol_data/10;
				freq_no=freq_no*100;
				if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
				if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
				if(freq_no_m!=freq_no){
					//if(out_flg==1){cpld_data_out(freq_no);}
					if(disp_count==0){
                        lcd_hz(freq_no);
                        ad9834_freq_set(freq_no,out_flg);
                    }
					freq_no_m=freq_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}

		if(vol_mode==1){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				vol_data=vol_yomi();
				freq_no=(unsigned long)vol_data/10;
				freq_no=freq_no*200;
				if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
				if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
				if(freq_no_m!=freq_no){
					//if(out_flg==1){cpld_data_out(freq_no);}
					if(disp_count==0){
                        lcd_hz(freq_no);
                        ad9834_freq_set(freq_no,out_flg);
                    }
					freq_no_m=freq_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}

		if(vol_mode==2){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				vol_data=vol_yomi();
				freq_no=(unsigned long)vol_data/10;
				freq_no=freq_no*500;
				if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
				if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
				if(freq_no_m!=freq_no){
					//if(out_flg==1){cpld_data_out(freq_no);}
					if(disp_count==0){
                        lcd_hz(freq_no);
                        ad9834_freq_set(freq_no,out_flg);
                    }
					freq_no_m=freq_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}

		if(vol_mode==3){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				vol_data=vol_yomi();
				freq_no=(unsigned long)vol_data/10;
				freq_no=freq_no*1000;
				if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
				if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
				if(freq_no_m!=freq_no){
					//if(out_flg==1){cpld_data_out(freq_no);}
					if(disp_count==0){
                        lcd_hz(freq_no);
                        ad9834_freq_set(freq_no,out_flg);
                    }
					freq_no_m=freq_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}
        
		if(vol_mode==4){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				vol_data=vol_yomi();
				freq_no=(unsigned long)vol_data/10;
				freq_no=freq_no*5000;
				if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
				if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
				if(freq_no_m!=freq_no){
					//if(out_flg==1){cpld_data_out(freq_no);}
					if(disp_count==0){
                        lcd_hz(freq_no);
                        ad9834_freq_set(freq_no,out_flg);
                    }
					freq_no_m=freq_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}        
        
 		if(vol_mode==5){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				vol_data=vol_yomi();
				freq_no=(unsigned long)vol_data/10;
				freq_no=freq_no*10000;
				if(freq_no<FREQ_MIN){freq_no=FREQ_MIN;}
				if(freq_no>FREQ_MAX){freq_no=FREQ_MAX;}
				if(freq_no_m!=freq_no){
					//if(out_flg==1){cpld_data_out(freq_no);}
					if(disp_count==0){
                        lcd_hz(freq_no);
                        ad9834_freq_set(freq_no,out_flg);
                    }
					freq_no_m=freq_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}        
        
		/**/
		}
        }

        /*-----------------------*/
        if(ms_mode==1){
            if(ms_count>0){ms_count--;}
            if(ms_count==0){
                if(freq_no>=1000000){
                    level_out(freq_no,ms_level);
                    ms_mode=0;
                    disp_count=DISP_LOOP_SET;
                    freq_no_m=0;
                    lcd_mode();
                }           
                else{
                    level_out(freq_no,ms_level);
                    freq_next();
                    lcd_hz(freq_no);
                    ad9834_freq_set(freq_no,out_flg);
                    disp_count=DISP_LOOP_MIN;                
                    ms_count=MS_COUNT_SET;
                    level_st_count=0;
                    level_count=LEVEL_COUNT_SET;
                }
            }
        }
        
        /*---------------*/
        if(level_count>0){level_count--;}
        if(level_count==0){
            level_data=level_yomi();
            level_st[level_st_count]=level_data;
            level_st_count++;
            if(level_st_count>4){
                level_st_count=0;
                level_data=(level_st[0]+level_st[1]+level_st[2]+level_st[3]+level_st[4])/5;
                ms_level=level_data;
                lcd_level((unsigned long)level_data);
                level_count=LEVEL_COUNT_SET;
            }
        }
        /*---------------*/

        if(disp_count>0){
            disp_count--;
            if(disp_count==0){

            }
        }
        
        
        

	}

}